Package: org.codehaus.groovy.control

## [Java] Class OptimizerVisitor

- org.codehaus.groovy.control.OptimizerVisitor

-     public class OptimizerVisitor
      extends ClassCodeExpressionTransformer

  Visitor to produce several optimizations:

  - to replace numbered constants with references to static fields
  - remove superfluous references to GroovyObject interface

- - ### Constructor Summary

    Constructors
    Constructor and description
    `OptimizerVisitor(CompilationUnit cu)` Creates an optimizer visitor.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected SourceUnit` | `getSourceUnit()` Returns the source unit currently being optimized.
    `` | `public Expression` | `transform(Expression exp)` Rewrites constant expressions that can be cached in synthetic fields.
    `` | `public void` | `visitClass(ClassNode node, SourceUnit source)` Applies optimizer rewrites to the supplied class.
    `` | `public void` | `visitClosureExpression(ClosureExpression expression)` Leaves closure bodies untouched so constant caching does not leak into closure classes.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeExpressionTransformer` | `setSourcePosition, transform, visitAnnotation, visitAssertStatement, visitCaseStatement, visitClosureExpression, visitConstructorOrMethod, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitProperty, visitReturnStatement, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitThrowStatement, visitWhileLoop, visitYieldStatement`
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop, visitYieldStatement`

- - ### Constructor Detail

    - #### public OptimizerVisitor(CompilationUnit cu)

      Creates an optimizer visitor.

      Parameters:
        `cu` - the owning compilation unit

  - ### Method Detail

    - #### protected SourceUnit getSourceUnit()

      Returns the source unit currently being optimized.

      Returns:
        the active source unit

    - #### public Expression transform(Expression exp)

      Rewrites constant expressions that can be cached in synthetic fields.

      Parameters:
        `exp` - the expression to transform
      Returns:
        the transformed expression

    - #### public void visitClass(ClassNode node, SourceUnit source)

      Applies optimizer rewrites to the supplied class.

      Parameters:
        `node` - the class to optimize
        `source` - the source unit containing the class

    - #### public void visitClosureExpression(ClosureExpression expression)

      Leaves closure bodies untouched so constant caching does not leak into closure classes.

      Parameters:
        `expression` - the closure expression being skipped